/* UpTools v8.6
 *
 * Copyright (c) 2005-2012 Fundacion Universidad de Palermo (Argentina).
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * 4. Redistributions of any form whatsoever must retain the following
 *    acknowledgment: 'This product includes software developed by the
 *    "Universidad de Palermo, Argentina" (http://www.palermo.edu/).'
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 * TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#ifndef UPRESOLVER_INL
#define UPRESOLVER_INL


/////////////////////////////////////////////////////////////////////////////
// inline methods for UpDnsQuery

inline
unsigned int UpDnsQuery::getCount() const
	{ return count; }
inline
unsigned int UpDnsQuery::getId() const
	{ return id; }
inline
queryStatus UpDnsQuery::getStatus() const
	{ return status; }
inline
const std::string& UpDnsQuery::getDomain() const
	{ return domain; }
inline
ns_type UpDnsQuery::getType() const
	{ return type; }
inline
UpResolver* UpDnsQuery::getResolverPtr() const
	{ return resolverPtr; }
inline
void UpDnsQuery::cancel() {
	UpResolver* rp(resolverPtr); // copy it first to temporal
	if(rp) {
		// this executes processCompletion() wich in turn resets resolverPtr
		rp->cancelQuery(*this); 
	}
}
inline
void UpDnsQuery::deleteRecords() {
   const UpResourceRecord *a=first,*b;
   while(a!=0) { b=a->next; delete a; a=b; }
	count = parsed = 0;
	first = current = 0;
}
inline
void UpDnsQuery::resetGetNext() {
	current=0;
}

#endif

