/* UpTools v8.6
 *
 * Copyright (c) 2005-2012 Fundacion Universidad de Palermo (Argentina).
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * 4. Redistributions of any form whatsoever must retain the following
 *    acknowledgment: 'This product includes software developed by the
 *    "Universidad de Palermo, Argentina" (http://www.palermo.edu/).'
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 * TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#ifndef UPSSL_INL
#define UPSSL_INL



//////////////////////////////////////////////////////////////////////////////
// inline methods ////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

inline
bool UpRsa::havePrivKey()
{ return privKey; }

inline
const std::string& UpRsa::getStatus()
{ return status; }

inline
const std::string& UpX509::getStatus()
{ return status; }

inline
const char* UpSsl::getErrBuf()
{ return sslErr ? errBuf : ""; }

inline
int UpSsl::getErr()
{ return sslErr; }

inline
bool UpSsl::checkErr( int sslRet ) {
	if( sslRet>=1 ) { sslErr=0; return true; }
	sslErr = SSL_get_error(ssl,sslRet);
	ERR_error_string(sslErr,errBuf);
	return false;
}

inline
void UpSsl::ctxErr() {
	sslErr=ERR_get_error();
	ERR_error_string(sslErr,errBuf);
}

inline
void UpSslContext::setErr(const char* errTxt) {
	sslErr=-1;
	if( errTxt ) strncpy(errBuf,errTxt,120);
}

inline
void UpSsl::setBidirectionalShutdown(bool t) {
	bidirectionalShutdown=t;
}


inline	
bool UpSslContext::checkErr(int sslRet) {
	if( sslRet==1 ) { sslErr=0; return true; }
	sslErr = ERR_get_error();
	ERR_error_string(sslErr,errBuf);
	return false;
}

inline
const char* UpSslContext::getErrBuf()
{ return sslErr ? errBuf : ""; }

inline int UpSsl::readPending()
{ return SSL_pending(ssl); }
#endif
