#ifndef UPTIMER_INL

////////////////////////////////////////////////////////////////////
// metodos de UpTimer

inline void UpTimer::repeat(const UpTimeVal& _interval, unsigned int _repeatCount)
	{ interval = _interval; count = _repeatCount+1; }

inline bool UpTimer::adminAction(const UpTimeVal& _now) { 
	if( action(_now) && --count ) { 
		when+=interval; 
		return true; 
	}
	return false;
}

inline UpTimer::UpTimer(const UpTimeVal& _when)
	: when(_when), interval(0), count(1), className(0) { }


inline UpTimer::UpTimer(const UpTimeVal& _when,const char* _className)
	: when(_when), interval(0), count(1), className(_className) { }

inline UpTimer::UpTimer(const UpTimeVal& _when, const UpTimeVal& _interval,
					unsigned int _repeatCount)
	: when(_when), interval(_interval), count(_repeatCount), className(0) { }

inline UpTimer::UpTimer(const UpTimeVal& _when, const UpTimeVal& _interval,
					unsigned int _repeatCount,const char* _className)
	: when(_when), interval(_interval), count(_repeatCount), className(_className) { }

inline UpTimer::~UpTimer()
	{}

inline bool UpTimer::operator<(const UpTimer& t) const
	{ return (when<t.when) ? true : ( (when>t.when) ? false : (this<&t) ) ; }

inline bool UpTimer::operator<(const UpTimeVal& t) const
	{ return (when<t); }
	
inline bool UpTimer::operator>(const UpTimeVal& t) const
	{ return (when>t); }

inline bool UpTimer::action(const UpTimeVal& _now)
	{ UPLOG(LOG_DEBUG,"UpTimer: dummy action"); return true; }

inline const char* UpTimer::name()
	{ return className; }
#endif
